unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, IdHTTP, IdSSLOpenSSL, Forms, Controls, Graphics,
  Dialogs, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    IdHTTP1: TIdHTTP;
    IdHTTP2: TIdHTTP;
    IdSSLIOHandlerSocketOpenSSL1: TIdSSLIOHandlerSocketOpenSSL;
    mInput: TMemo;
    moutput: TMemo;
    procedure Button1Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var
  request:TIdHTTPRequest;
  response:TIdHTTPResponse;
  streamInput:TMemoryStream;
  streamOutput:TStream;
  requestQuery:String;
begin
   try
    streamOutput := TMemoryStream.Create;
    streamInput := TMemoryStream.Create;

    IdSSLIOHandlerSocketOpenSSL1.SSLOptions.CertFile := 'test-tls.cer';
    IdSSLIOHandlerSocketOpenSSL1.SSLOptions.Method := TIdSSLVersion.sslvTLSv1_2;

    IdHTTP1.IOHandler := IdSSLIOHandlerSocketOpenSSL1;

    request := TIdHTTPRequest.Create(IdHTTP1);

    requestQuery:='<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:fu="http://www.fu.gov.si/" xmlns:xd="http://www.w3.org/2000/09/xmldsig#">'+
                  '<soapenv:Body>'+
                  '<fu:EchoRequest>test echo</fu:EchoRequest>'+
                  '</soapenv:Body>'+
                  '</soapenv:Envelope>';
    mInput.Lines.Add(requestQuery);
    minput.Lines.SaveToStream(streamInput);
    streamInput.Position := 0;

    request.Source := streamInput;
    request.Method := 'POST';
    request.Accept := 'text/xml';
    request.Connection := 'KeepAlive';
    request.ContentType := 'text/xml; charset=utf-8';  // 'application/soap+xml'
    request.CustomHeaders.Add('SOAPAction: /echo');

    IdHTTP1.Post('https://blagajne-test.fu.gov.si:9002/v1/cash_registers', streamInput);

    response := IdHTTP1.Response;

    streamOutput := response.ContentStream;

    streamOutput.Position := 0;
    moutput.Lines.LoadFromStream(streamOutput);

  finally
    streamInput.Free;
    streamOutput.Free;
  end;
end;

end.

